searchNodes=[{"type":"extras","title":"Raspberry Pi Zero 2 W and 3 A+ (64-bit)","doc":"This is the base Nerves System configuration for the Raspberry Pi Zero 2 W with the USB port running in gadget mode. It is similar to nerves_system_rpi3a except that it runs the ARM Cortex-A53 in 64-bit mode to support the Erlang JIT . &lt;sup&gt;[Image credit](#rpi)&lt;/sup&gt; Feature Description CPU 1.4 GHz quad-core ARM Cortex-A53 Memory 512 MB DRAM Storage MicroSD Linux kernel 6.1 w/ Raspberry Pi patches IEx terminal UART ttyAMA0 Can be changed to HDMI GPIO, I2C, SPI Yes - Elixir Circuits ADC No PWM Yes, but no Elixir support UART 1 available - ttyAMA0 Display HDMI or 7&quot; RPi Touchscreen Camera Official RPi Cameras (libcamera) Ethernet No WiFi Yes Bluetooth See Bluetooth Audio HDMI out","ref":"readme.html"},{"type":"extras","title":"Raspberry Pi Zero 2 W and 3 A+ (64-bit) - Using","doc":"The most common way of using this Nerves System is create a project with mix nerves.new and to export MIX_TARGET=rpi0_2 . See the Getting started guide for more information. If you need custom modifications to this system for your device, clone this repository and update as described in Making custom systems .","ref":"readme.html#using"},{"type":"extras","title":"Raspberry Pi Zero 2 W and 3 A+ (64-bit) - Supported WiFi devices","doc":"The base image includes drivers for the onboard Raspberry Pi Zero 2 wifi module ( brcmfmac driver).","ref":"readme.html#supported-wifi-devices"},{"type":"extras","title":"Raspberry Pi Zero 2 W and 3 A+ (64-bit) - Camera","doc":"This system supports the official Raspberry Pi camera modules via libcamera . The libcamera applications are included so it's possible to replicate many of the examples in the official Raspberry Pi Camera Documentation . Here's an example commandline to run: cmd ( &quot;libcamera-jpeg -n -v -o /data/test.jpeg&quot; ) On success, you'll get an image in /data that you can copy off with sftp . Since libcamera is being used instead of MMAL, the Elixir picam library won't work.","ref":"readme.html#camera"},{"type":"extras","title":"Raspberry Pi Zero 2 W and 3 A+ (64-bit) - Bluetooth","doc":"BlueHeronTransportUART supports Bluetooth on the Raspberry Pi Zero 2 W using ttyS0 . The details are similar to the [RPi Zero W] ( https://github.com/nerves-project/nerves_system_rpi0/issues/224#issuecomment-913799838 ).","ref":"readme.html#bluetooth"},{"type":"extras","title":"Raspberry Pi Zero 2 W and 3 A+ (64-bit) - Audio","doc":"The Raspberry Pi has many options for audio output. This system supports the HDMI and stereo audio jack output. The Linux ALSA drivers are used for audio output. The general Raspberry Pi audio documentation mostly applies to Nerves. For example, to force audio out the HDMI port, run: cmd ( &quot;amixer cset numid=3 2&quot; ) Change the last argument to amixer to 1 to output to the stereo output jack.","ref":"readme.html#audio"},{"type":"extras","title":"Raspberry Pi Zero 2 W and 3 A+ (64-bit) - Gadget mode on the 3A+!","doc":"The Raspberry Pi 3 Model A+ is supported by the official nerves_system_rpi3 , but the USB port is configured to work as a host only. This Raspberry Pi can be connected directly to your computer via a USB cable like the Raspberry Pi Zeros. To do this, you'll need a USB A to USB A connector like this or this .","ref":"readme.html#gadget-mode-on-the-3a"},{"type":"extras","title":"Raspberry Pi Zero 2 W and 3 A+ (64-bit) - Linux's preempt_rt patches","doc":"If you need better real-time performance from the Linux kernel, the preempt_rt patch set may help. Be aware that we do not test with the patches so this may not work. To enable it, make a custom system using this one as a base and add the following to the nerves_defconfig : BR2_LINUX_KERNEL_PATCH=&quot;http://cdn.kernel.org/pub/linux/kernel/projects/rt/4.19/patch-4.19.25-rt16.patch.xz&quot; Please verify the patch version since these instructions may be out-of-date. Next, update the Linux configuration to use it. Review the Nerves documentation for running make linux-menuconfig and enable PREEMPT_RT_FULL . Alternately, make the following change to the Linux configuration: -CONFIG_PREEMPT=y +CONFIG_PREEMPT_RT_FULL=y Build the system and you should now have a preempt_rt kernel.","ref":"readme.html#linux-s-preempt_rt-patches"},{"type":"extras","title":"Raspberry Pi Zero 2 W and 3 A+ (64-bit) - Provisioning devices","doc":"This system supports storing provisioning information in a small key-value store outside of any filesystem. Provisioning is an optional step and reasonable defaults are provided if this is missing. Provisioning information can be queried using the Nerves.Runtime KV store's Nerves.Runtime.KV.get/1 function. Keys used by this system are: Key Example Value Description nerves_serial_number &quot;12345678&quot; By default, this string is used to create unique hostnames and Erlang node names. If unset, it defaults to part of the Raspberry Pi's device ID. The normal procedure would be to set these keys once in manufacturing or before deployment and then leave them alone. For example, to provision a serial number on a running device, run the following and reboot: iex&gt; cmd ( &quot;fw_setenv nerves_serial_number 12345678&quot; ) This system supports setting the serial number offline. To do this, set the NERVES_SERIAL_NUMBER environment variable when burning the firmware. If you're programming MicroSD cards using fwup , the commandline is: sudo NERVES_SERIAL_NUMBER=12345678 fwup path_to_firmware.fw Serial numbers are stored on the MicroSD card so if the MicroSD card is replaced, the serial number will need to be reprogrammed. The numbers are stored in a U-boot environment block. This is a special region that is separate from the application partition so reformatting the application partition will not lose the serial number or any other data stored in this block. Additional key value pairs can be provisioned by overriding the default provisioning.conf file location by setting the environment variable NERVES_PROVISIONING=/path/to/provisioning.conf . The default provisioning.conf will set the nerves_serial_number , if you override the location to this file, you will be responsible for setting this yourself.","ref":"readme.html#provisioning-devices"},{"type":"extras","title":"Raspberry Pi Zero 2 W and 3 A+ (64-bit) - Linux kernel and RPi firmware/userland","doc":"There's a subtle coupling between the nerves_system_br version and the Linux kernel version used here. nerves_system_br provides the versions of rpi-userland and rpi-firmware that get installed. I prefer to match them to the Linux kernel to avoid any issues. Unfortunately, none of these are tagged by the Raspberry Pi Foundation so I either attempt to match what's in Raspbian or take versions of the repositories that have similar commit times. Image credit : This image is from raspberrypi.org .","ref":"readme.html#linux-kernel-and-rpi-firmware-userland"},{"type":"extras","title":"Changelog","doc":"This project does NOT follow semantic versioning. The version increases as follows: Major version updates are breaking updates to the build infrastructure. These should be very rare. Minor version updates are made for every major Buildroot release. This may also include Erlang/OTP and Linux kernel updates. These are made four times a year shortly after the Buildroot releases. Patch version updates are made for Buildroot minor releases, Erlang/OTP releases, and Linux kernel updates. They're also made to fix bugs and add features to the build infrastructure.","ref":"changelog.html"},{"type":"extras","title":"Changelog - v1.23.0","doc":"This is a major update that brings in Erlang/OTP 26, Buildroot 2023.02.2, Linux 6.1, and Raspberry Pi firmware updates. New features The Raspberry Pi cameras now work with libcamera. The libcamera apps are included. See the Raspberry Pi Camera docs . CA certificates are included for OTP 26. Changes The start.elf and fixup.dat files were renamed to start4.elf and fixup4.dat to be more consistent with the RaspberryPi OS naming. Updated dependencies nerves_system_br v1.23.1 Buildroot 2023.02.2 Erlang/OTP 26.0.2 Linux 6.1.21 (Raspberry Pi Linux tag 1.20230405)","ref":"changelog.html#v1-23-0"},{"type":"extras","title":"Changelog - Previous releases","doc":"This is a fork of nerves_system_rpi3a . See that project for previous history. The version numbers were kept for convenience.","ref":"changelog.html#previous-releases"}]